# Fourteenth International Obfuscated C Code Contest


## Standard IOCCC stuff

View the `index.html` web page for the given winning entry for information on how
on how to compile it and how to run the winning program.
Look at the winning source and try to figure how it does what it does!
You may then wish to look at the Author's remarks for even more details.

The IOCCC has its own domain.  The IOCCC has an official home page:
[www.ioccc.org](https://www.ioccc.org).

Use `make` to compile entries.  It is possible that on BSD or non-Unix
systems the Makefile needs to be changed.  See the Makefile for details.

Read over the Makefile for compile/build issues.  Your system may
require certain changes (add or remove a library, add or remove a
`#define` i.e. the `-D` flag).

Some ANSI C compilers are not quite as good as they should be.  If
yours is lacking, you may need to compile using gcc instead of your
local compiler.


## New Judges

Larry Bassel is now a graduate student in number theory at UC San Diego.
Barbara Frezza also went to San Diego to enter into law school at the
same time.  Her cooking in the role of official chef was sorely missed.
Both Larry and Barbara have taken important new steps in their lives.
We wish them the best.

Landon was unable to contact Sriram Srinivasan at the start of
the 1998 IOCCC season.  Having not heard from Sriram, Landon put out
a call for new IOCCC judges.  A number of excellent people applied.

Landon selected Leonid A. Broukhis, a two time IOCCC winning author, as a
co-judge.   Landon and Leo together selected Jeremy Horn and Peter
Seebach.  The four [judges](https://www.ioccc.org/judges.html) together worked
thru-out the 1998 IOCCC season.


### 2023 note about judges:

The number of judges now is only 2, Landon Curt Noll and Leonid A. Broukhis.

## Remarks on some of the entries

This year, [Jens
Schweikhardt](https://www.ioccc.org/authors.html#Jens_Schweikhardt) won 3 times
... AGAIN!  He is the only person who was able to do this, let alone do it in
two contests in a row. [Bas de
Bakker](https://www.ioccc.org/authors.html#Bas_de_Bakker) and [David
Lowe](https://www.ioccc.org/authors.html#J_David_Lowe) won twice this year as
well.

As we stated in the [guidelines](guidelines.txt), the authors of the winning entries are
as much news to us as they are to you because we keep authorship separate from
rest of the entry.  Some people have it, we guess!

There were a few very good entries that might have won if it were not
for the fact that they didn't work.  If you didn't win, but think you
had a chance: test your program, fix it and submit it next year!

This year we awarded some outstanding entries.  We recommend that you
look at all of the winning entries.  The list of winning entries is a bit too long to
say something about every entry.  On the other hand a partial mention
of a few is in order:

- Audiences were very impressed with the Best of Show entry.
- The judges were amused that for the first time we received an entry
  that caused gcc to give the assembler bad input in some cases.
- The poot entries got a good laugh from the USENIX IOCCC BOF (Birds Of a Feather) crowd.
- Those with Functional Programming knowledge as well as those
  impressed with CPP code expansion liked the entry that translated
  lambda expressions into combinator expressions.
- Logic minded folks will get somewhat twisted up while following the
  flow of the [Best Flow Control entry](schnitzi/index.html).
- Those who know the PostScript language will be 'bemused' by
  the [Best Encapsulation entry](bas1/index.html).

There were some outstanding entries that did not win.  Unfortunately
some very good entries lost because they:

- depended too much on non-portable side effects in expressions;
- depended too much on a particular byte order;
- required the use of a special script, data file or pseudo-machine language
that was not supplied with the entry.

We hope the authors of some of those entries will fix and re-submit
them for the next IOCCC.


## There was no 1997 contest

So what happened to 1997?  There was no summer USENIX Technical
Conference.  The Technical Conference was held Jun 15-19, 1998 instead
... 18 months later than the 1996 summer USENIX Technical Conference.
In addition we had to select some new IOCCC judges.  As a result the IOCCC
skipped over 1997.


## Final Comments

Please send us comments and suggestions what we have expressed above.
Also include anything else that you would like to see in future contests.
Send such email to:

```
questions@ioccc.org
```

**IMPORTANT NOTE**: The email addresses found above are for historical
purposes only, and should not be used today.  See
[contact.html](../contact.html) for up to date contact details
as well as details on how to provide fixes to any of the entries.
See also [the IOCCC FAQ](../faq.html) for addition information on the IOCCC.

If you use, distribute or publish these entries in some way, please drop
us a line.  We enjoy seeing who, where and how the contest is used.

You must include the words 'ioccc question' in the subject of your email
message when sending email to the judges.

The next IOCCC is planned to start towards the end of 1999.  Watch
[www.ioccc.org](https://www.ioccc.org) for news of the next contest.


<!--

    Copyright © 1984-2024 by Landon Curt Noll. All Rights Reserved.

    You are free to share and adapt this file under the terms of this license:

	Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

    For more information, see:

	https://creativecommons.org/licenses/by-sa/4.0/

-->
